var canvas, context;
var gImage;
var WIDTH, HEIGHT;
var frameRate = 5;
var refreshCount = 0;
var battery;
var currentFrame;
var TIMELINE_MAX_VALUE = 24 * 60 * 60 * frameRate;
var dayOfWeek = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];
var dayOfWeekFull = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
var monthStr = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
var monthStrFull = ["January", "Febuary", "March", "April", "May", "Jun", "July", "August", "September", "October", "November", "December"];
var maximumDays = [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];

var Background1ButtonArea = [0, 0, 360, 360];
var Background1ButtonIndex = 0;
var Background1ButtonImage = ["engryBG01.png"];
var Digitalclock1BitmapStrImages = [];
var Digitalclock1BitmapStrKey = ["am", "pm"];
var Digitalclock1BitmapStr = ["", ""];
var Digitalclock1Images = [];
var Digitalclock1Bitmap = ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "0.png", "1.png", "2.png", "3.png", "4.png", "5.png", "6.png", "7.png", "8.png", "9.png", "colon.png", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""];
var Text1BitmapStrImages = [];
var Text1BitmapStrKey = ["am", "pm"];
var Text1BitmapStr = ["", ""];
var Text1Images = [];
var Text1Bitmap = ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "0.png", "1.png", "2.png", "3.png", "4.png", "5.png", "6.png", "7.png", "8.png", "9.png", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""];
var Text2BitmapStrImages = [];
var Text2BitmapStrKey = ["am", "pm"];
var Text2BitmapStr = ["", ""];
var Text2Images = [];
var Text2Bitmap = ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "0.png", "1.png", "2.png", "3.png", "4.png", "5.png", "6.png", "7.png", "8.png", "9.png", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""];
var Digitalclock2BitmapStrImages = [];
var Digitalclock2BitmapStrKey = ["am", "pm"];
var Digitalclock2BitmapStr = ["", ""];
var Digitalclock2Images = [];
var Digitalclock2Bitmap = ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "0.png", "1.png", "2.png", "3.png", "4.png", "5.png", "6.png", "7.png", "8.png", "9.png", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""];
var DaysofweekBitmapStrImages = [];
var DaysofweekBitmapStrKey = ["am", "pm"];
var DaysofweekBitmapStr = ["", ""];
var DaysofweekImages = [];
var DaysofweekBitmap = ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "1.png", "2.png", "3.png", "4.png", "5.png", "6.png", "7.png", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""];
var daysofmounthBitmapStrImages = [];
var daysofmounthBitmapStrKey = ["am", "pm"];
var daysofmounthBitmapStr = ["", ""];
var daysofmounthImages = [];
var daysofmounthBitmap = ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "0.png", "1.png", "2.png", "3.png", "4.png", "5.png", "6.png", "7.png", "8.png", "9.png", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""];
var Digitalclock3BitmapStrImages = [];
var Digitalclock3BitmapStrKey = ["am", "pm"];
var Digitalclock3BitmapStr = ["AM.png", "PM.png"];
var Digitalclock3Images = [];
var Digitalclock3Bitmap = ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""];

window.requestAnimationFrame ||
    window.webkitRequestAnimationFrame ||
    window.mozRequestAnimationFrame ||
    window.oRequestAnimationFrame ||
    window.msRequestAnimationFrame ||
    function (/* function */ callback) {
        'use strict';
        window.setTimeout(callback, 1000 / frameRate);
    };

function getDate() {
    'use strict';

    var date;
    try {
        date = tizen.time.getCurrentDateTime();
    } catch (err) {
        console.error('Error: ', err.message);
        date = new Date();
    }

    return date;
}

function findByValue(isTime, array, value) {
    if (isTime) {
        if (value === TIMELINE_MAX_VALUE) {
            value = 0;
        }

        for (var i = 0; i<array.length; i++) {
            if (array[i][0] <= value && array[i][1] > value) {
                return true;
            }
        }
    } else {
        for (var i = 0; i<array.length; i++) {
            if (array[i][0] <= value && array[i][1] >= value) {
                return true;
            }
        }
    }

    return false;
}

function refresh() {
    'use strict';
    //Erase the previous time
    context.clearRect(0, 0, context.canvas.width, context.canvas.height);

    //Import the current time
    var date = getDate();
    var hours = date.getHours();
    var minutes = date.getMinutes();
    var seconds = date.getSeconds();
    var hour = hours + minutes / 60;
    var minute = minutes + seconds / 60;
    var milliseconds = seconds + date.getMilliseconds()/1000.0;
    var frame = parseInt(date.getMilliseconds()/(1000/frameRate));
    var angle;
    var text;
    var extent;
    var nextX;

    hours = hours > 12 ? hours - 12 : hours;
    currentFrame = (date.getHours() * frameRate * 60 * 60) + (minutes * frameRate * 60) + (seconds * frameRate) + frame;
    context.save();

    gImage.src = '' + Background1ButtonImage[Background1ButtonIndex];
    context.drawImage(imgengryBG01png, 0, 0, 360, 360);
    context.restore();
    context.save();

    text = ((hours<10) ? "0"+hours : hours.toString()) + " : " + ((minutes<10) ? "0"+minutes : minutes.toString());
    {
        var width = 0;
        var charImage;
        var i, j, strChar;
        var tokens = text.split(" ");
        var path;
        var paths = [];
        var isWord;
    
        for (i = 0; i<tokens.length; i++) {
            isWord = false;
            for (j = 0; j<Digitalclock1BitmapStr.length; j++) {
                if (tokens[i] === Digitalclock1BitmapStrKey[j]) {
                    charImage = Digitalclock1BitmapStrImages[j];
                    width += charImage.width;
                    paths.push(charImage);
                    isWord = true;
                }
            }
    
            if (!isWord) {
                for (j = 0; j<tokens[i].length; j++) {
                    strChar = tokens[i].charCodeAt(j);
                    if (strChar >= 0x20 && strChar <= 0x7E) {
                        if (Digitalclock1Bitmap[strChar - 0x20] !== "") {
                            charImage = Digitalclock1Images[strChar - 0x20];
                            width += charImage.width;
                            paths.push(charImage);
                        }
                    }
                }
            }
        }
    
        var startX = 180 - width/2;
        for (i = 0; i<paths.length; i++) {
            charImage = paths[i];
            context.drawImage(charImage, startX, 84 - charImage.height/2, charImage.width, charImage.height);
            startX += charImage.width;
        }
    }

    text =  + " steps";
    {
        var width = 0;
        var charImage;
        var i, j, strChar;
        var tokens = text.split(" ");
        var path;
        var paths = [];
        var isWord;
    
        for (i = 0; i<tokens.length; i++) {
            isWord = false;
            for (j = 0; j<Text1BitmapStr.length; j++) {
                if (tokens[i] === Text1BitmapStrKey[j]) {
                    charImage = Text1BitmapStrImages[j];
                    width += charImage.width;
                    paths.push(charImage);
                    isWord = true;
                }
            }
    
            if (!isWord) {
                for (j = 0; j<tokens[i].length; j++) {
                    strChar = tokens[i].charCodeAt(j);
                    if (strChar >= 0x20 && strChar <= 0x7E) {
                        if (Text1Bitmap[strChar - 0x20] !== "") {
                            charImage = Text1Images[strChar - 0x20];
                            width += charImage.width;
                            paths.push(charImage);
                        }
                    }
                }
            }
        }
    
        var startX = 198 - width/2;
        for (i = 0; i<paths.length; i++) {
            charImage = paths[i];
            context.drawImage(charImage, startX, 323 - charImage.height/2, charImage.width, charImage.height);
            startX += charImage.width;
        }
    }

    context.translate(44, 186);
    context.rotate(357.06432655357884*Math.PI/180);
    text = Math.floor(battery.level*100) + " %";
    {
        var width = 0;
        var charImage;
        var i, j, strChar;
        var tokens = text.split(" ");
        var path;
        var paths = [];
        var isWord;
    
        for (i = 0; i<tokens.length; i++) {
            isWord = false;
            for (j = 0; j<Text2BitmapStr.length; j++) {
                if (tokens[i] === Text2BitmapStrKey[j]) {
                    charImage = Text2BitmapStrImages[j];
                    width += charImage.width;
                    paths.push(charImage);
                    isWord = true;
                }
            }
    
            if (!isWord) {
                for (j = 0; j<tokens[i].length; j++) {
                    strChar = tokens[i].charCodeAt(j);
                    if (strChar >= 0x20 && strChar <= 0x7E) {
                        if (Text2Bitmap[strChar - 0x20] !== "") {
                            charImage = Text2Images[strChar - 0x20];
                            width += charImage.width;
                            paths.push(charImage);
                        }
                    }
                }
            }
        }
    
        var startX = 0 - width/2;
        for (i = 0; i<paths.length; i++) {
            charImage = paths[i];
            context.drawImage(charImage, startX, 0 - charImage.height/2, charImage.width, charImage.height);
            startX += charImage.width;
        }
    }

    context.translate(47, 215);
    context.rotate(4.1849161251184155*Math.PI/180);
    text = ((date.getHours()<10) ? "0"+date.getHours() : date.getHours().toString());
    {
        var width = 0;
        var charImage;
        var i, j, strChar;
        var tokens = text.split(" ");
        var path;
        var paths = [];
        var isWord;
    
        for (i = 0; i<tokens.length; i++) {
            isWord = false;
            for (j = 0; j<Digitalclock2BitmapStr.length; j++) {
                if (tokens[i] === Digitalclock2BitmapStrKey[j]) {
                    charImage = Digitalclock2BitmapStrImages[j];
                    width += charImage.width;
                    paths.push(charImage);
                    isWord = true;
                }
            }
    
            if (!isWord) {
                for (j = 0; j<tokens[i].length; j++) {
                    strChar = tokens[i].charCodeAt(j);
                    if (strChar >= 0x20 && strChar <= 0x7E) {
                        if (Digitalclock2Bitmap[strChar - 0x20] !== "") {
                            charImage = Digitalclock2Images[strChar - 0x20];
                            width += charImage.width;
                            paths.push(charImage);
                        }
                    }
                }
            }
        }
    
        var startX = 0 - width/2;
        for (i = 0; i<paths.length; i++) {
            charImage = paths[i];
            context.drawImage(charImage, startX, 0 - charImage.height/2, charImage.width, charImage.height);
            startX += charImage.width;
        }
    }

    context.translate(137, 122);
    context.rotate(356.9059419410829*Math.PI/180);
    text = date.getDay();
    {
        var width = 0;
        var charImage;
        var i, j, strChar;
        var tokens = text.split(" ");
        var path;
        var paths = [];
        var isWord;
    
        for (i = 0; i<tokens.length; i++) {
            isWord = false;
            for (j = 0; j<DaysofweekBitmapStr.length; j++) {
                if (tokens[i] === DaysofweekBitmapStrKey[j]) {
                    charImage = DaysofweekBitmapStrImages[j];
                    width += charImage.width;
                    paths.push(charImage);
                    isWord = true;
                }
            }
    
            if (!isWord) {
                for (j = 0; j<tokens[i].length; j++) {
                    strChar = tokens[i].charCodeAt(j);
                    if (strChar >= 0x20 && strChar <= 0x7E) {
                        if (DaysofweekBitmap[strChar - 0x20] !== "") {
                            charImage = DaysofweekImages[strChar - 0x20];
                            width += charImage.width;
                            paths.push(charImage);
                        }
                    }
                }
            }
        }
    
        var startX = 0 - width/2;
        for (i = 0; i<paths.length; i++) {
            charImage = paths[i];
            context.drawImage(charImage, startX, 0 - charImage.height/2, charImage.width, charImage.height);
            startX += charImage.width;
        }
    }

    text = ((date.getDate()<10) ? "0"+date.getDate() : date.getDate().toString());
    {
        var width = 0;
        var charImage;
        var i, j, strChar;
        var tokens = text.split(" ");
        var path;
        var paths = [];
        var isWord;
    
        for (i = 0; i<tokens.length; i++) {
            isWord = false;
            for (j = 0; j<daysofmounthBitmapStr.length; j++) {
                if (tokens[i] === daysofmounthBitmapStrKey[j]) {
                    charImage = daysofmounthBitmapStrImages[j];
                    width += charImage.width;
                    paths.push(charImage);
                    isWord = true;
                }
            }
    
            if (!isWord) {
                for (j = 0; j<tokens[i].length; j++) {
                    strChar = tokens[i].charCodeAt(j);
                    if (strChar >= 0x20 && strChar <= 0x7E) {
                        if (daysofmounthBitmap[strChar - 0x20] !== "") {
                            charImage = daysofmounthImages[strChar - 0x20];
                            width += charImage.width;
                            paths.push(charImage);
                        }
                    }
                }
            }
        }
    
        var startX = 186 - width/2;
        for (i = 0; i<paths.length; i++) {
            charImage = paths[i];
            context.drawImage(charImage, startX, 120 - charImage.height/2, charImage.width, charImage.height);
            startX += charImage.width;
        }
    }

    context.translate(241, 122);
    context.rotate(5.440332031005506*Math.PI/180);
    text = (date.getHours()<12 ? 'am' : 'pm');
    {
        var width = 0;
        var charImage;
        var i, j, strChar;
        var tokens = text.split(" ");
        var path;
        var paths = [];
        var isWord;
    
        for (i = 0; i<tokens.length; i++) {
            isWord = false;
            for (j = 0; j<Digitalclock3BitmapStr.length; j++) {
                if (tokens[i] === Digitalclock3BitmapStrKey[j]) {
                    charImage = Digitalclock3BitmapStrImages[j];
                    width += charImage.width;
                    paths.push(charImage);
                    isWord = true;
                }
            }
    
            if (!isWord) {
                for (j = 0; j<tokens[i].length; j++) {
                    strChar = tokens[i].charCodeAt(j);
                    if (strChar >= 0x20 && strChar <= 0x7E) {
                        if (Digitalclock3Bitmap[strChar - 0x20] !== "") {
                            charImage = Digitalclock3Images[strChar - 0x20];
                            width += charImage.width;
                            paths.push(charImage);
                        }
                    }
                }
            }
        }
    
        var startX = 0 - width/2;
        for (i = 0; i<paths.length; i++) {
            charImage = paths[i];
            context.drawImage(charImage, startX, 0 - charImage.height/2, charImage.width, charImage.height);
            startX += charImage.width;
        }
    }

    context.restore();
    window.requestAnimationFrame(refresh);
    refreshCount++;
}

window.onload = function () {
    'use strict';
    canvas = document.getElementById('clock');
    console.log('onload called');
    context = canvas.getContext('2d');

    canvas.width = document.width;
    canvas.height = document.height;

    WIDTH = document.width;
    HEIGHT = document.height;

    gImage = new Image();

    battery = navigator.battery || navigator.webkitBattery || navigator.mozBattery;

    //add eventListener for tizenhwkey
    window.addEventListener('tizenhwkey', function (e) {
        if (e.keyName == 'back') {
            try {
                tizen.application.getCurrentApplication().exit();
            } catch (err) {
                console.log('Error: ', err.message);
            }
        }
    });

    window.requestAnimationFrame(refresh);

    var i;
    for (i = 0; i<95; i++) {
        if (Digitalclock1Bitmap[i] !== "") {
            Digitalclock1Images[i] = new Image();
            Digitalclock1Images[i].src = "res/fonts/bitmap_0/" + Digitalclock1Bitmap[i];
        }
    }
    for (i = 0; i<2; i++) {
        if (Digitalclock1BitmapStr[i] !== "") {
            Digitalclock1BitmapStrImages[i] = new Image();
            Digitalclock1BitmapStrImages[i].src = "res/fonts/bitmap_0/" + Digitalclock1BitmapStr[i];
        }
    }
    var i;
    for (i = 0; i<95; i++) {
        if (Text1Bitmap[i] !== "") {
            Text1Images[i] = new Image();
            Text1Images[i].src = "res/fonts/bitmap_1/" + Text1Bitmap[i];
        }
    }
    for (i = 0; i<2; i++) {
        if (Text1BitmapStr[i] !== "") {
            Text1BitmapStrImages[i] = new Image();
            Text1BitmapStrImages[i].src = "res/fonts/bitmap_1/" + Text1BitmapStr[i];
        }
    }
    var i;
    for (i = 0; i<95; i++) {
        if (Text2Bitmap[i] !== "") {
            Text2Images[i] = new Image();
            Text2Images[i].src = "res/fonts/bitmap_2/" + Text2Bitmap[i];
        }
    }
    for (i = 0; i<2; i++) {
        if (Text2BitmapStr[i] !== "") {
            Text2BitmapStrImages[i] = new Image();
            Text2BitmapStrImages[i].src = "res/fonts/bitmap_2/" + Text2BitmapStr[i];
        }
    }
    var i;
    for (i = 0; i<95; i++) {
        if (Digitalclock2Bitmap[i] !== "") {
            Digitalclock2Images[i] = new Image();
            Digitalclock2Images[i].src = "res/fonts/bitmap_3/" + Digitalclock2Bitmap[i];
        }
    }
    for (i = 0; i<2; i++) {
        if (Digitalclock2BitmapStr[i] !== "") {
            Digitalclock2BitmapStrImages[i] = new Image();
            Digitalclock2BitmapStrImages[i].src = "res/fonts/bitmap_3/" + Digitalclock2BitmapStr[i];
        }
    }
    var i;
    for (i = 0; i<95; i++) {
        if (DaysofweekBitmap[i] !== "") {
            DaysofweekImages[i] = new Image();
            DaysofweekImages[i].src = "res/fonts/bitmap_4/" + DaysofweekBitmap[i];
        }
    }
    for (i = 0; i<2; i++) {
        if (DaysofweekBitmapStr[i] !== "") {
            DaysofweekBitmapStrImages[i] = new Image();
            DaysofweekBitmapStrImages[i].src = "res/fonts/bitmap_4/" + DaysofweekBitmapStr[i];
        }
    }
    var i;
    for (i = 0; i<95; i++) {
        if (daysofmounthBitmap[i] !== "") {
            daysofmounthImages[i] = new Image();
            daysofmounthImages[i].src = "res/fonts/bitmap_5/" + daysofmounthBitmap[i];
        }
    }
    for (i = 0; i<2; i++) {
        if (daysofmounthBitmapStr[i] !== "") {
            daysofmounthBitmapStrImages[i] = new Image();
            daysofmounthBitmapStrImages[i].src = "res/fonts/bitmap_5/" + daysofmounthBitmapStr[i];
        }
    }
    var i;
    for (i = 0; i<95; i++) {
        if (Digitalclock3Bitmap[i] !== "") {
            Digitalclock3Images[i] = new Image();
            Digitalclock3Images[i].src = "res/fonts/bitmap_6/" + Digitalclock3Bitmap[i];
        }
    }
    for (i = 0; i<2; i++) {
        if (Digitalclock3BitmapStr[i] !== "") {
            Digitalclock3BitmapStrImages[i] = new Image();
            Digitalclock3BitmapStrImages[i].src = "res/fonts/bitmap_6/" + Digitalclock3BitmapStr[i];
        }
    }
    window.addEventListener('touchstart', function (e) {
        if (e.changedTouches[0].clientX >= Background1ButtonArea[0] && e.changedTouches[0].clientX < Background1ButtonArea[2] && e.changedTouches[0].clientY >= Background1ButtonArea[1] && e.changedTouches[0].clientY < Background1ButtonArea[3]) {
            Background1ButtonIndex++;
            if (Background1ButtonIndex >= Background1ButtonImage.length) {
                Background1ButtonIndex = 0;
            }
        }
    });
};
